<template>
    <div class="register">
        <h1>สมัครสมาชิก</h1>
        <img src="../assets/register.png" alt="login" width="500px">
        <div class="registerForm">
            <md-field :class="usernameError">
                <label>ชื่อผู้ใช้</label>
                <md-input v-model="username" required></md-input>
                <span class="md-error" v-if="usernameRequired">ต้องป้อนชื่อผู้ใช้</span>
            </md-field>

            <md-field :class="emailError">
                <label>อีเมลล์</label>
                <md-input v-model="email" type="email" required></md-input>
                <span class="md-error" v-if="emailRequired">ต้องป้อนอีเมลล์</span>
                <span class="md-error" v-else-if="emailInvalid">รูปแบบอีเมลล์ไม่ถูกต้อง</span>
            </md-field>

            <div>
                <md-field :class="passwordError">
                    <label>รหัสผ่าน</label>
                    <md-input v-model="password" type="password" required></md-input>
                    <span class="md-error" v-if="passwordRequired">ต้องป้อนรหัสผ่าน</span>
                    <span class="md-error" v-else-if="passwordLength">รหัสผ่านต้องยาวมากกว่า 8 ตัวอักษร</span>
                </md-field>

                <md-field :class="checkPasswordError">
                    <label>ยืนยันรหัสผ่าน</label>
                    <md-input v-model="passwordCheck" type="password" required></md-input>
                    <span class="md-error" v-if="passwordCheckRequired">ต้องป้อนยืนยันรหัสผ่าน</span>
                    <span class="md-error" v-else-if="passwordNotMatch">รหัสผ่านไม่ตรงกัน</span>
                </md-field>
            </div>

            <md-checkbox v-model="accept" class="md-primary md-caption">อนุญาตให้เราเก็บข้อมูลของคุณ</md-checkbox>

            <md-button class="md-raised md-primary registerBtn" @click="register">สมัครสมาชิก</md-button>
            
        </div>
    </div>
</template>

<script>
export default {
    name: 'Register',
    metaInfo: {
        title: 'สมัครสมาชิก'
    },
    data() {
        return {
            username: '',
            email: '',
            password: '',
            passwordCheck: '',
            accept: false,
            usernameRequired: false,
            emailRequired: false,
            emailInvalid: false,
            passwordRequired: false,
            passwordLength: false,
            passwordNotMatch: false,
            passwordCheckRequired: false,
        }
    },
    methods: {
        register() {
            //Check username is required
            if(this.username === '') this.usernameRequired = true
            else this.usernameRequired = false

            //Check password is required
            if(this.email === '') this.emailRequired = true
            else this.emailRequired = false

            //Check email is valid
            if(validationEmail(this.email) === false) this.emailInvalid = true
            else this.emailInvalid = false

            //Check password is required
            if(this.password === '') this.passwordRequired = true
            else this.passwordRequired = false

            //Check password must be more than 8 characters.
            if(this.password.length < 8) this.passwordLength = true
            else this.passwordLength = false

            //Check passowrd and password check is match
            if(this.passwordCheck !== this.password) this.passwordNotMatch = true
            else this.passwordNotMatch = false

            //Check passwordcheck is required
            if(this.passwordCheck === '') this.passwordCheckRequired = true
            else this.passwordCheckRequired = false

            //Function for check email is valid
            function validationEmail(email) {
                const re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                return re.test(String(email).toLowerCase());
            }
        },
    },
    computed: {
        usernameError() {
            return { 'md-invalid': this.usernameRequired }
        },
        emailError() {
            if(this.emailRequired === true)
                return { 'md-invalid': this.emailRequired }
            else if(this.emailInvalid === true)
                return {'md-invalid' : this.emailInvalid}
        },
        passwordError() {
            return { 'md-invalid': this.passwordRequired }
        },
        checkPasswordError() {
            if(this.passwordCheckRequired === true)
                return { 'md-invalid': (this.passwordCheckRequired) }
            else if(this.passwordNotMatch === true)
                return { 'md-invalid': (this.passwordNotMatch) }
        }
    }
}
</script>

<style lang="scss" scoped>
h1 {
    font-size: 2.5rem;
}

.register {
    display: flex;
    flex-direction: column;
    align-items: center;
    text-align: center;
}

.registerForm {
    width: 350px;
}

.registerBtn {
    width: 100%;
    padding: 0;
    margin: 0;
    margin-top: 1rem;
}
</style>